## SUMMARY
The reason for this module is we want to have a way to define permissions for nodes depending on the taxonomy terms they
have.

We have been using other modules for this purpose, but are not happy with the implementation which is not clear to us.

On the taxonomy term, we have a field that defines the roles that have access to it and one for the specific users.
When applying the taxonomy term to a node, we store invoking the `hook_node_access_records` the roles and the users
that are given grants to access the node.

When a user tries to access a node, then we use the `hook_node_grants` to return the grants the user has. Core does the
rest of the work.

## FUNCTIONALITY
We have the REALMS:
- __ACCESS_BY_TAXONOMY_ROLE_REALM__: This is the realm used for nodes that are restricted by taxonomy terms.
- __ACCESS_BY_TAXONOMY_USER_REALM__: This is the realm used for nodes that are restricted to one or more users.
- __ACCESS_BY_TAXONOMY_OWNER_REALM__: This is the realm used for nodes that are restricted. This allows the owner of the node to access it.
- __ACCESS_BY_TAXONOMY_OWN_UNPUBLISHED_REALM__: This is the realm used for unpublished nodes and allows access for the owner.
- __ACCESS_BY_TAXONOMY_VIEW_ANY_REALM__: This is the realm used for nodes that are restricted, allows users with a specific permission to view any node of a certain type.

For the __ACCESS_BY_TAXONOMY_ROLE_REALM__, we define the GID as the role ID, starting from 1. When we load a node,
we return the GID array of the roles a user has. Core then gives them access to the node if there are any entries in the
node_access table for that GID.

For the __ACCESS_BY_TAXONOMY_USER_REALM__, we define the GID as the user ID. When we load a node, we return the GID of
the user ID. Core then gives them access to the node if there are any entries in the node_access table for that GID.
